﻿//
//Unified Write Filter Utility
//Annabooks, LLC.
//Copyright (c) 2016 Annabooks, LLC. All Rights Reserved
//
//
//The sample application demonstrates some basic Unified Write Filter WMI APIs in C#
//
//
//Date: 12/2/2016 - Comments generated
//
//Source code provided as is without any warranty
//

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Management;

namespace UWFUtility
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            UWFStatus();
        }

        public void UWFStatus()
        {
            ManagementScope scope = new ManagementScope(@"root\standardcimv2\embedded");
            ManagementClass UWFFilter = new ManagementClass(scope.Path.Path, "UWF_Filter", null);
            ManagementClass UWFOverlayConfig = new ManagementClass(scope.Path.Path, "UWF_OverlayConfig", null);
            ManagementClass UWFOverlay = new ManagementClass(scope.Path.Path, "UWF_Overlay", null);
            ManagementClass UWFServicing = new ManagementClass(scope.Path.Path, "UWF_Servicing", null);

            foreach (ManagementObject mo in UWFFilter.GetInstances())
            {
                if (mo.GetPropertyValue("CurrentEnabled").ToString() == "True")
                {
                    txtCurrentState.Text = "Enabled";
                }
                else
                {
                    txtCurrentState.Text = "Disabled";
                }
                if (mo.GetPropertyValue("NextEnabled").ToString() == "True")
                {
                    txtNextState.Text = "Enabled";
                }
                else
                {
                    txtNextState.Text = "Disabled";
                }
            }

            foreach (ManagementObject mo in UWFOverlayConfig.GetInstances())
            {
                if (mo.GetPropertyValue("Type").ToString() == "0")
                {
                    txtOverlayType.Text = "RAM";
                }
                else
                {
                    txtOverlayType.Text = "Disk";
                }

                txtMaxSize.Text = mo.GetPropertyValue("MaximumSize").ToString();
            }

            foreach (ManagementObject mo in UWFOverlay.GetInstances())
            {
                txtWarningThreshold.Text = mo.GetPropertyValue("WarningOverlayThreshold").ToString();
                txtCriticalThreshold.Text = mo.GetPropertyValue("CriticalOverlayThreshold").ToString();
            }

            foreach (ManagementObject mo in UWFServicing.GetInstances())
            {
                if (mo.GetPropertyValue("ServicingEnabled").ToString() == "True")
                {
                    txtService.Text = "On";
                }
                else
                {
                    txtService.Text = "Off";
                }
            }
        }

        private void btnEnable_Click_1(object sender, EventArgs e)
        {
            ManagementScope scope = new ManagementScope(@"root\standardcimv2\embedded");
            ManagementClass UWFFilter = new ManagementClass(scope.Path.Path, "UWF_Filter", null);

            foreach (ManagementObject mo in UWFFilter.GetInstances())
            {
                ManagementBaseObject UWFEnable = mo.InvokeMethod("Enable", null, null);
            }
            UWFStatus();
        }

        private void btnDisable_Click_1(object sender, EventArgs e)
        {
            ManagementScope scope = new ManagementScope(@"root\standardcimv2\embedded");
            ManagementClass UWFFilter = new ManagementClass(scope.Path.Path, "UWF_Filter", null);

            foreach (ManagementObject mo in UWFFilter.GetInstances())
            {
                ManagementBaseObject UWFEnable = mo.InvokeMethod("Disable", null, null);

            }
            UWFStatus();
        }
    }
}
